#
# DO NOT MODIFY!!!!
# This file is automatically generated by Racc 1.7.3
# from Racc grammar file "parser.racc".
#

require 'racc/parser.rb'

require 'date'

require File.dirname(__FILE__) + '/parser.rex.rb'

module GitlabZOQL
  class Parser < Racc::Parser

module_eval(<<'...end parser.racc/module_eval...', 'parser.racc', 140)

def self.parse(zoql)
  new.scan_str(zoql)
end
...end parser.racc/module_eval...
##### State transition tables begin ###

racc_action_table = [
    23,    35,    36,   -10,   -49,   -28,   -10,   -49,     6,    41,
    52,   -28,   -28,    63,    17,    21,     7,    24,    41,    26,
    30,    28,    29,    17,    21,   -49,    24,    41,    26,    33,
    28,    29,    17,    21,   -51,    24,    41,    26,    34,    28,
    29,    17,    21,    44,    24,    41,    26,    45,    28,    29,
    17,    21,    46,    24,    48,    26,    51,    28,    29,    17,
    21,    41,    24,    52,    26,    79,    28,    29,    52,    52,
    41,    63,    63,    58,    81,    17,    21,    59,    24,    41,
    26,    68,    28,    29,    17,    21,    69,    24,    41,    26,
    52,    28,    29,    17,    21,    69,    24,    41,    26,   nil,
    28,    29,    17,    21,   nil,    24,    41,    26,   nil,    28,
    29,    17,    21,   nil,    24,   nil,    26,   nil,    28,    29,
    17,    21,   nil,    24,   -27,    26,   -29,    28,    29,   -30,
   -27,   -27,   -29,   -29,   -31,   -30,   -30,   -32,    37,    38,
   -31,   -31,   nil,   -32,   -32,    71,   nil,    72,    73,    74,
    75,    76,    43,    42,    35,    36,    35,    36 ]

racc_action_check = [
     6,    15,    15,    12,    23,    80,    12,    23,     0,    17,
    48,    80,    80,    48,     6,     6,     1,     6,    35,     6,
     7,     6,     6,    17,    17,    23,    17,    36,    17,     8,
    17,    17,    35,    35,    10,    35,    37,    35,    11,    35,
    35,    36,    36,    26,    36,    38,    36,    28,    36,    36,
    37,    37,    29,    37,    32,    37,    33,    37,    37,    38,
    38,    71,    38,    34,    38,    71,    38,    38,    68,    69,
    72,    68,    69,    42,    72,    71,    71,    45,    71,    73,
    71,    60,    71,    71,    72,    72,    61,    72,    74,    72,
    63,    72,    72,    73,    73,    77,    73,    75,    73,   nil,
    73,    73,    74,    74,   nil,    74,    76,    74,   nil,    74,
    74,    75,    75,   nil,    75,   nil,    75,   nil,    75,    75,
    76,    76,   nil,    76,    82,    76,    83,    76,    76,    84,
    82,    82,    83,    83,    85,    84,    84,    86,    16,    16,
    85,    85,   nil,    86,    86,    65,   nil,    65,    65,    65,
    65,    65,    24,    24,    56,    56,    57,    57 ]

racc_action_pointer = [
     6,    16,   nil,   nil,   nil,   nil,    -5,    20,    26,   nil,
    13,    17,     3,   nil,   nil,   -14,   121,     4,   nil,   nil,
   nil,   nil,   nil,     4,   130,   nil,    18,   nil,    20,    26,
   nil,   nil,    50,    51,    58,    13,    22,    31,    40,   nil,
   nil,   nil,    51,   nil,   nil,    51,   nil,   nil,     5,   nil,
   nil,   nil,   nil,   nil,   nil,   nil,   139,   141,   nil,   nil,
    75,    79,   nil,    85,   nil,   137,   nil,   nil,    63,    64,
   nil,    56,    65,    74,    83,    92,   101,    88,   nil,   nil,
     5,   nil,   124,   126,   129,   134,   137 ]

racc_action_default = [
   -62,   -62,    -1,    -2,    -3,    -4,   -62,   -62,    -6,    -7,
    -8,    -9,   -44,   -33,   -34,   -37,   -40,   -62,   -42,   -43,
   -45,   -46,   -47,   -52,   -62,   -55,   -62,   -57,   -61,   -62,
    87,    -5,   -14,   -62,   -62,   -62,   -62,   -62,   -62,   -41,
   -44,   -52,   -62,   -54,   -56,   -59,   -60,   -11,   -62,   -12,
   -13,   -16,   -49,   -50,   -33,   -33,   -37,   -37,   -53,   -58,
   -15,   -17,   -19,   -62,   -22,   -62,   -25,   -26,   -62,   -62,
   -21,   -62,   -62,   -62,   -62,   -62,   -62,   -18,   -20,   -23,
   -44,   -24,   -44,   -44,   -44,   -44,   -44 ]

racc_goto_table = [
    12,    10,    61,    54,    55,    56,    57,     1,     2,     3,
     4,     5,     8,    31,     9,    11,    32,    47,    49,    50,
    60,    78,    77,    70,    39,   nil,   nil,   nil,   nil,    53,
   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,
   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,
   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,
   nil,   nil,   nil,   nil,   nil,    80,    82,    83,    84,    85,
    86 ]

racc_goto_check = [
    11,     9,    17,    22,    22,    24,    24,     1,     2,     3,
     4,     5,     6,     7,     8,    10,    12,    13,    14,    15,
    16,    18,    17,    19,    26,   nil,   nil,   nil,   nil,     9,
   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,
   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,
   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,
   nil,   nil,   nil,   nil,   nil,    11,    11,    11,    11,    11,
    11 ]

racc_goto_pointer = [
   nil,     7,     8,     9,    10,    11,     6,     5,     8,    -5,
     9,    -6,     8,   -15,   -15,   -14,   -28,   -46,   -48,   -40,
   nil,   nil,   -32,   nil,   -32,   nil,     7,   nil,   nil,   nil,
   nil,   nil ]

racc_goto_default = [
   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,    65,
   nil,    40,   nil,   nil,   nil,   nil,   nil,   nil,    62,    64,
    67,    66,    13,    14,    15,    16,    18,    19,    20,    22,
    25,    27 ]

racc_reduce_table = [
  0, 0, :racc_error,
  1, 29, :_reduce_none,
  1, 30, :_reduce_none,
  1, 31, :_reduce_3,
  1, 32, :_reduce_none,
  3, 33, :_reduce_5,
  2, 33, :_reduce_6,
  1, 34, :_reduce_7,
  1, 36, :_reduce_none,
  1, 36, :_reduce_none,
  1, 36, :_reduce_none,
  2, 35, :_reduce_11,
  2, 40, :_reduce_12,
  1, 42, :_reduce_none,
  0, 41, :_reduce_none,
  2, 41, :_reduce_15,
  1, 43, :_reduce_16,
  1, 44, :_reduce_none,
  3, 44, :_reduce_18,
  1, 45, :_reduce_none,
  3, 45, :_reduce_20,
  2, 46, :_reduce_21,
  1, 46, :_reduce_none,
  3, 48, :_reduce_23,
  3, 48, :_reduce_24,
  1, 47, :_reduce_none,
  1, 47, :_reduce_none,
  3, 49, :_reduce_27,
  3, 49, :_reduce_28,
  3, 49, :_reduce_29,
  3, 49, :_reduce_30,
  3, 49, :_reduce_31,
  3, 49, :_reduce_32,
  1, 39, :_reduce_none,
  1, 39, :_reduce_none,
  3, 50, :_reduce_35,
  3, 50, :_reduce_36,
  1, 50, :_reduce_none,
  3, 52, :_reduce_38,
  3, 52, :_reduce_39,
  1, 52, :_reduce_none,
  2, 53, :_reduce_41,
  1, 53, :_reduce_none,
  1, 54, :_reduce_none,
  1, 54, :_reduce_44,
  1, 55, :_reduce_none,
  1, 55, :_reduce_none,
  1, 56, :_reduce_none,
  1, 56, :_reduce_none,
  1, 37, :_reduce_49,
  3, 38, :_reduce_50,
  1, 38, :_reduce_none,
  1, 51, :_reduce_52,
  3, 51, :_reduce_53,
  2, 51, :_reduce_54,
  1, 51, :_reduce_none,
  2, 58, :_reduce_56,
  1, 57, :_reduce_none,
  3, 59, :_reduce_58,
  2, 59, :_reduce_59,
  2, 59, :_reduce_60,
  1, 59, :_reduce_61 ]

racc_reduce_n = 62

racc_shift_n = 87

racc_token_table = {
  false => 0,
  :error => 1,
  :SELECT => 2,
  :FROM => 3,
  :WHERE => 4,
  :identifier => 5,
  :OR => 6,
  :AND => 7,
  :not_equals_operator => 8,
  :NULL => 9,
  :equals_operator => 10,
  :less_than_operator => 11,
  :greater_than_operator => 12,
  :less_than_or_equals_operator => 13,
  :greater_than_or_equals_operator => 14,
  :plus_sign => 15,
  :minus_sign => 16,
  :asterisk => 17,
  :solidus => 18,
  :sign => 19,
  :general_value_specification => 20,
  :comma => 21,
  :quote => 22,
  :character_string_literal => 23,
  :DATETIME => 24,
  :datetime_string => 25,
  :unsigned_integer => 26,
  :period => 27 }

racc_nt_base = 28

racc_use_result_var = true

Racc_arg = [
  racc_action_table,
  racc_action_check,
  racc_action_default,
  racc_action_pointer,
  racc_goto_table,
  racc_goto_check,
  racc_goto_default,
  racc_goto_pointer,
  racc_nt_base,
  racc_reduce_table,
  racc_token_table,
  racc_shift_n,
  racc_reduce_n,
  racc_use_result_var ]
Ractor.make_shareable(Racc_arg) if defined?(Ractor)

Racc_token_to_s_table = [
  "$end",
  "error",
  "SELECT",
  "FROM",
  "WHERE",
  "identifier",
  "OR",
  "AND",
  "not_equals_operator",
  "NULL",
  "equals_operator",
  "less_than_operator",
  "greater_than_operator",
  "less_than_or_equals_operator",
  "greater_than_or_equals_operator",
  "plus_sign",
  "minus_sign",
  "asterisk",
  "solidus",
  "sign",
  "general_value_specification",
  "comma",
  "quote",
  "character_string_literal",
  "DATETIME",
  "datetime_string",
  "unsigned_integer",
  "period",
  "$start",
  "direct_sql_statement",
  "direct_sql_data_statement",
  "direct_select_statement_multiple_rows",
  "query_expression",
  "query_specification",
  "select_list",
  "table_expression",
  "select_sublist",
  "column_name",
  "column_name_list",
  "value_expression",
  "from_clause",
  "where_clause",
  "table_reference",
  "table_name",
  "search_condition",
  "boolean_term",
  "boolean_factor",
  "predicate",
  "null_predicate",
  "comparison_predicate",
  "numeric_value_expression",
  "general_literal",
  "term",
  "factor",
  "value_expression_primary",
  "unsigned_value_specification",
  "unsigned_literal",
  "unsigned_numeric_literal",
  "datetime_literal",
  "exact_numeric_literal" ]
Ractor.make_shareable(Racc_token_to_s_table) if defined?(Ractor)

Racc_debug_parser = false

##### State transition tables end #####

# reduce 0 omitted

# reduce 1 omitted

# reduce 2 omitted

module_eval(<<'.,.,', 'parser.racc', 12)
  def _reduce_3(val, _values, result)
     result = GitlabZOQL::Parser::Statement::DirectSelect.new(val[0])
    result
  end
.,.,

# reduce 4 omitted

module_eval(<<'.,.,', 'parser.racc', 19)
  def _reduce_5(val, _values, result)
     result = GitlabZOQL::Parser::Statement::Select.new(val[1], val[2])
    result
  end
.,.,

module_eval(<<'.,.,', 'parser.racc', 20)
  def _reduce_6(val, _values, result)
     result = GitlabZOQL::Parser::Statement::Select.new(val[1])
    result
  end
.,.,

module_eval(<<'.,.,', 'parser.racc', 23)
  def _reduce_7(val, _values, result)
     result = GitlabZOQL::Parser::Statement::SelectList.new(val[0])
    result
  end
.,.,

# reduce 8 omitted

# reduce 9 omitted

# reduce 10 omitted

module_eval(<<'.,.,', 'parser.racc', 31)
  def _reduce_11(val, _values, result)
     result = GitlabZOQL::Parser::Statement::TableExpression.new(val[0], val[1])
    result
  end
.,.,

module_eval(<<'.,.,', 'parser.racc', 34)
  def _reduce_12(val, _values, result)
     result = GitlabZOQL::Parser::Statement::FromClause.new(val[1])
    result
  end
.,.,

# reduce 13 omitted

# reduce 14 omitted

module_eval(<<'.,.,', 'parser.racc', 41)
  def _reduce_15(val, _values, result)
     result = GitlabZOQL::Parser::Statement::WhereClause.new(val[1])
    result
  end
.,.,

module_eval(<<'.,.,', 'parser.racc', 45)
  def _reduce_16(val, _values, result)
     result = GitlabZOQL::Parser::Statement::Table.new(val[0])
    result
  end
.,.,

# reduce 17 omitted

module_eval(<<'.,.,', 'parser.racc', 50)
  def _reduce_18(val, _values, result)
     result = GitlabZOQL::Parser::Statement::Or.new(val[0], val[2])
    result
  end
.,.,

# reduce 19 omitted

module_eval(<<'.,.,', 'parser.racc', 54)
  def _reduce_20(val, _values, result)
     result = GitlabZOQL::Parser::Statement::And.new(val[0], val[2])
    result
  end
.,.,

module_eval(<<'.,.,', 'parser.racc', 57)
  def _reduce_21(val, _values, result)
     result = GitlabZOQL::Parser::Statement::Not.new(val[1])
    result
  end
.,.,

# reduce 22 omitted

module_eval(<<'.,.,', 'parser.racc', 61)
  def _reduce_23(val, _values, result)
     result = GitlabZOQL::Parser::Statement::Not.new(GitlabZOQL::Parser::Statement::Equals.new(val[0], GitlabZOQL::Parser::Statement::Null.new))
    result
  end
.,.,

module_eval(<<'.,.,', 'parser.racc', 62)
  def _reduce_24(val, _values, result)
     result = GitlabZOQL::Parser::Statement::Equals.new(val[0], GitlabZOQL::Parser::Statement::Null.new)
    result
  end
.,.,

# reduce 25 omitted

# reduce 26 omitted

module_eval(<<'.,.,', 'parser.racc', 69)
  def _reduce_27(val, _values, result)
     result = GitlabZOQL::Parser::Statement::Equals.new(val[0], val[2])
    result
  end
.,.,

module_eval(<<'.,.,', 'parser.racc', 70)
  def _reduce_28(val, _values, result)
     result = GitlabZOQL::Parser::Statement::Not.new(GitlabZOQL::Parser::Statement::Equals.new(val[0], val[2]))
    result
  end
.,.,

module_eval(<<'.,.,', 'parser.racc', 71)
  def _reduce_29(val, _values, result)
     result = GitlabZOQL::Parser::Statement::Less.new(val[0], val[2])
    result
  end
.,.,

module_eval(<<'.,.,', 'parser.racc', 72)
  def _reduce_30(val, _values, result)
     result = GitlabZOQL::Parser::Statement::Greater.new(val[0], val[2])
    result
  end
.,.,

module_eval(<<'.,.,', 'parser.racc', 73)
  def _reduce_31(val, _values, result)
     result = GitlabZOQL::Parser::Statement::LessOrEquals.new(val[0], val[2])
    result
  end
.,.,

module_eval(<<'.,.,', 'parser.racc', 74)
  def _reduce_32(val, _values, result)
     result = GitlabZOQL::Parser::Statement::GreaterOrEquals.new(val[0], val[2])
    result
  end
.,.,

# reduce 33 omitted

# reduce 34 omitted

module_eval(<<'.,.,', 'parser.racc', 81)
  def _reduce_35(val, _values, result)
     result = GitlabZOQL::Parser::Statement::Add.new(val[0], val[2])
    result
  end
.,.,

module_eval(<<'.,.,', 'parser.racc', 82)
  def _reduce_36(val, _values, result)
     result = GitlabZOQL::Parser::Statement::Subtract.new(val[0], val[2])
    result
  end
.,.,

# reduce 37 omitted

module_eval(<<'.,.,', 'parser.racc', 86)
  def _reduce_38(val, _values, result)
     result = GitlabZOQL::Parser::Statement::Multiply.new(val[0], val[2])
    result
  end
.,.,

module_eval(<<'.,.,', 'parser.racc', 87)
  def _reduce_39(val, _values, result)
     result = GitlabZOQL::Parser::Statement::Divide.new(val[0], val[2])
    result
  end
.,.,

# reduce 40 omitted

module_eval(<<'.,.,', 'parser.racc', 91)
  def _reduce_41(val, _values, result)
     result = val[0].new(val[1])
    result
  end
.,.,

# reduce 42 omitted

# reduce 43 omitted

module_eval(<<'.,.,', 'parser.racc', 96)
  def _reduce_44(val, _values, result)
     result = val[0]
    result
  end
.,.,

# reduce 45 omitted

# reduce 46 omitted

# reduce 47 omitted

# reduce 48 omitted

module_eval(<<'.,.,', 'parser.racc', 108)
  def _reduce_49(val, _values, result)
     result = GitlabZOQL::Parser::Statement::Column.new(val[0])
    result
  end
.,.,

module_eval(<<'.,.,', 'parser.racc', 111)
  def _reduce_50(val, _values, result)
     result = Array(val[0]) + Array(val[2])
    result
  end
.,.,

# reduce 51 omitted

module_eval(<<'.,.,', 'parser.racc', 116)
  def _reduce_52(val, _values, result)
     result = GitlabZOQL::Parser::Statement::Identifier.new(val[0])
    result
  end
.,.,

module_eval(<<'.,.,', 'parser.racc', 117)
  def _reduce_53(val, _values, result)
     result = GitlabZOQL::Parser::Statement::Literal.new(val[1])
    result
  end
.,.,

module_eval(<<'.,.,', 'parser.racc', 118)
  def _reduce_54(val, _values, result)
     result = GitlabZOQL::Parser::Statement::String.new('')
    result
  end
.,.,

# reduce 55 omitted

module_eval(<<'.,.,', 'parser.racc', 122)
  def _reduce_56(val, _values, result)
     result = GitlabZOQL::Parser::Statement::DateTime.new(val[1])
    result
  end
.,.,

# reduce 57 omitted

module_eval(<<'.,.,', 'parser.racc', 128)
  def _reduce_58(val, _values, result)
     result = GitlabZOQL::Parser::Statement::Float.new("#{val[0]}.#{val[2]}".to_f)
    result
  end
.,.,

module_eval(<<'.,.,', 'parser.racc', 129)
  def _reduce_59(val, _values, result)
     result = GitlabZOQL::Parser::Statement::Float.new(val[0])
    result
  end
.,.,

module_eval(<<'.,.,', 'parser.racc', 130)
  def _reduce_60(val, _values, result)
     result = GitlabZOQL::Parser::Statement::Float.new("0.#{val[1]}".to_f)
    result
  end
.,.,

module_eval(<<'.,.,', 'parser.racc', 131)
  def _reduce_61(val, _values, result)
     result = GitlabZOQL::Parser::Statement::Integer.new(val[0])
    result
  end
.,.,

def _reduce_none(val, _values, result)
  val[0]
end

  end   # class Parser
end   # module GitlabZOQL
